package edu.villanova.ftp.command;

import java.util.Properties;
import java.io.FileInputStream;
import java.io.File;
import edu.villanova.ftp.util.Loader;

public class CommandListFactory {

  public static CommandList loadCommandList(String file) throws Exception {
    CommandList list = new CommandList();
    Properties commands = new Properties();
    commands.load(new FileInputStream(new File(file)));
    Object[] keys = commands.keySet().toArray();
    for(int i=0;i<keys.length;i++) {
      ICommand com = (ICommand)Loader.load(commands.getProperty((String)keys[i]));
      list.commands.put(keys[i],com);
    }
    return list;
  }
}