package edu.villanova.ftp.command;

import java.util.Date;
import java.io.PrintWriter;
import java.io.File;
import edu.villanova.ftp.security.IFtpAccount;

public class Cwd implements ICommand {

  public boolean run(IFtpAccount user) {
    PrintWriter out = user.getOut();
    String host = user.getHost();
    String uid = user.getUID();
    String command = user.getCommand();
    String currDir = user.getCurrentDirectory();
    try {
      int space = command.indexOf(" ");
      String fs = System.getProperties().getProperty("file.separator");
      String file = command.substring(space,command.length()).trim();
      String newdir = "";
      if(file.equals("..")) {
        char[] path = currDir.toCharArray();
        char f = fs.charAt(0);
        int last = path.length;
        int length = 0;
        for(int i=path.length-2;i>=length;i--) {
          if(path[i]==f) {
            last = i;
            break;
          }
        }
        newdir = currDir.substring(0,last);
      } else {
        if(file.startsWith(currDir) || currDir.startsWith(file))
          newdir = file;
        else if(currDir.endsWith(fs))
          newdir = currDir + file;
        else
          newdir = currDir + fs + file;
      }
      if(!(new File(newdir)).isDirectory()) {
        out.println("550 " + newdir + ": Not a directory");
      } else if((new File(newdir)).exists()) {
        user.setCurrentDirectory(newdir);
        out.println("250 CWD was successful");
      } else {
        out.println("550 " + newdir + ": No such file or directory");
      }
      return true;
    } catch(Exception e){
      System.err.println(new Date() + ":" + getName() + ":" + host + ":" + uid);
      e.printStackTrace();
      return false;
    }
  }

  public String getName() {
    return "CWD";
  }
}