package edu.villanova.ftp.command;

import java.io.File;
import java.io.PrintWriter;
import java.io.IOException;
import java.util.Date;
import edu.villanova.ftp.security.IFtpAccount;

public class Delete implements ICommand {

  public boolean run(IFtpAccount user) {
    PrintWriter out = user.getOut();
    String host = user.getHost();
    String uid = user.getUID();
    String command = user.getCommand();
    String currDir = user.getCurrentDirectory();
    try {
      String file = command.substring(4);
      file = file.trim();
      File f = new File(currDir,file);
      if(f.exists()) {
        boolean del = f.delete();
        if(del)
          out.println("250 delete command successful");
        else
          throw new IOException();
      } else {
        out.println("550 " + file + ": No such file or directory.");
      }
      return true;
    } catch(Exception e){
      System.err.println(new Date() + ":" + getName() + ":" + host + ":" + uid);
      e.printStackTrace();
      return false;
    }
  }

  public String getName() {
    return "DELE";
  }
}