package edu.villanova.ftp.command;

import java.io.PrintWriter;
import java.io.OutputStream;
import java.io.RandomAccessFile;
import java.io.File;
import java.net.Socket;
import java.util.Date;
import edu.villanova.ftp.security.IFtpAccount;

public class Get implements ICommand {

  public boolean run(IFtpAccount user) {
    PrintWriter out = user.getOut();
    String host = user.getHost();
    String uid = user.getUID();
    String command = user.getCommand();
    String currDir = user.getCurrentDirectory();
    int port = user.getPort();
    String fs = System.getProperties().getProperty("file.separator");
    try {
      String file = command.substring(4);
      file = file.trim();
      if(new File(currDir,file).exists()) {
        out.println("150 Binary data connection");
        RandomAccessFile outFile = new RandomAccessFile(currDir+fs+file,"r");
        Socket t = new Socket(host,port);
        OutputStream out2 = t.getOutputStream();
        byte bb[] = new byte[1024];
        int amount;
        while((amount = outFile.read(bb)) != -1) {
          out2.write(bb, 0, amount);
        }
        out2.close();
        out.println("226 transfer complete");
        outFile.close();
        t.close();
      } else {
        out.println("550 " + file + ": No such file or directory");
      }
      return true;
    } catch(Exception e) {
      System.err.println(new Date() + ":" + getName() + ":" + host + ":" + uid);
      e.printStackTrace();
      return false;
    }
  }

  public String getName() {
    return "RETR";
  }
}
