package edu.villanova.ftp.command;

import java.io.PrintWriter;
import java.io.File;
import java.net.Socket;
import java.util.Date;
import java.text.SimpleDateFormat;
import edu.villanova.ftp.security.IFtpAccount;

public class List implements ICommand {

  String name;
  SimpleDateFormat format = new SimpleDateFormat("MMM dd hh:mm");

  public boolean run(IFtpAccount user) {
    PrintWriter out = user.getOut();
    String host = user.getHost();
    String uid = user.getUID();
    String currDir = user.getCurrentDirectory();
    int port = user.getPort();
    String fs = System.getProperties().getProperty("file.separator");
    try {
      out.println("150 ASCII data");
      Socket socket = new Socket(host,port);
      PrintWriter out2 = new PrintWriter(socket.getOutputStream(),true);
      File dir = new File(currDir);
      String[] files = null;
      files = dir.list();
      String di = "";
      for(int i=0;i<files.length;i++) {
        File tmp = new File(currDir + fs + files[i]);
        if(tmp.isDirectory()) {
          di = "d";
        } else {
          di = "-";
        }
        if(tmp.canRead()) {
          di = di + "r";
        } else {
          di = di + "-";
        }
        if(tmp.canWrite()) {
          di = di + "w";
        } else {
          di = di + "-";
        }
        //drw              xrwxrwx   1 owner    group               0 Apr  9 16:25 Archive
        int width = (""+tmp.length()).length();
        StringBuffer group = new StringBuffer("group");
        //group.setLength(16 - width);
        //"-------   1 owner\tgroup\t"
        out2.println(di + "-------   1 owner    " + group.toString() + "    " + tmp.length() + " " + format.format(new Date(tmp.lastModified())) + " " +files[i]);
        //out2.println(di + " " + files[i]);
      }
      out2.close();
      socket.close();
      out.println("226 transfer complete");
      return true;
    } catch(Exception e) {
      System.err.println(new Date() + ":" + getName() + ":" + host + ":" + uid);
      e.printStackTrace();
      return false;
    }
  }

  public String getName() {
    return "LIST";
  }
}