package edu.villanova.ftp.command;

import java.util.Date;
import java.io.PrintWriter;
import java.io.File;
import edu.villanova.ftp.security.IFtpAccount;

public class Mkdir implements ICommand {

  public boolean run(IFtpAccount user) {
    PrintWriter out = user.getOut();
    String host = user.getHost();
    String uid = user.getUID();
    String command = user.getCommand();
    String currDir = user.getCurrentDirectory();
    try {
      int space = command.indexOf(" ");
      String file = command.substring(space,command.length()).trim();
      String newfile = "";
      if(currDir.endsWith(System.getProperties().getProperty("file.separator")))
        newfile = currDir + file;
      else
        newfile = currDir + System.getProperties().getProperty("file.separator") + file;
      File newdir = new File(newfile);
      newdir.mkdir();
      out.println("257 MKD command successful");
      return true;
    } catch(Exception e){
      System.err.println(new Date() + ":" + getName() + ":" + host + ":" + uid);
      e.printStackTrace();
      return false;
    }
  }

  public String getName() {
    return "MKD";
  }
}