package edu.villanova.ftp.command;

import java.io.PrintWriter;
import java.io.InputStream;
import java.io.RandomAccessFile;
import java.net.Socket;
import java.util.Date;
import edu.villanova.ftp.security.IFtpAccount;

public class Put implements ICommand {

  public boolean run(IFtpAccount user) {
    PrintWriter out = user.getOut();
    String host = user.getHost();
    String uid = user.getUID();
    String command = user.getCommand();
    String currDir = user.getCurrentDirectory();
    int port = user.getPort();
    String fs = System.getProperties().getProperty("file.separator");
    try {
      out.println("150 Binary data connection");
      String file = command.substring(4);
      file = file.trim();
      RandomAccessFile inFile = new RandomAccessFile(currDir+fs+file,"rw");
      Socket t = new Socket(host,port);
      InputStream in2 = t.getInputStream();
      byte bb[] = new byte[1024];
      int amount;
      while((amount = in2.read(bb)) != -1) {
       inFile.write(bb, 0, amount);
     }
      in2.close();
      out.println("226 transfer complete");
      inFile.close();
      t.close();
      return true;
    } catch(Exception e){
      System.err.println(new Date() + ":" + getName() + ":" + host + ":" + uid);
      e.printStackTrace();
      return false;
    }
  }

  public String getName() {
    return "STOR";
  }
}