package edu.villanova.ftp.command;

import java.util.Date;
import java.io.PrintWriter;
import java.io.File;
import edu.villanova.ftp.security.IFtpAccount;

public class Rnfr implements ICommand {

  public boolean run(IFtpAccount user) {
    PrintWriter out = user.getOut();
    String host = user.getHost();
    String uid = user.getUID();
    String command = user.getCommand();
    String currDir = user.getCurrentDirectory();
    String fs = System.getProperties().getProperty("file.separator");
    try {
      String file = command.substring(4).trim();
      if((new File(currDir+fs+file)).exists()) {
        out.println("350 File exists, ready for destination name");
      } else {
        out.println("503 Bad sequence of commands");
      }
      return true;
    } catch(Exception e){
      System.err.println(new Date() + ":" + getName() + ":" + host + ":" + uid);
      e.printStackTrace();
      return false;
    }
  }

  public String getName() {
    return "RNFR";
  }
}