package edu.villanova.ftp.command;

import java.util.Date;
import java.io.PrintWriter;
import java.io.File;
import edu.villanova.ftp.security.IFtpAccount;

public class Rnto implements ICommand {

  public boolean run(IFtpAccount user) {
    PrintWriter out = user.getOut();
    String host = user.getHost();
    String uid = user.getUID();
    String command = user.getCommand();
    String lastCommand = user.getLastCommand();
    String currDir = user.getCurrentDirectory();
    String fs = System.getProperties().getProperty("file.separator");
    try {
      String file    = lastCommand.substring(4).trim();
      String newfile = command.substring(4).trim();
      if((new File(currDir+fs+file)).renameTo(new File(currDir+fs+newfile))) {
        out.println("250 RNTO was successful");
      } else {
        out.println("550 " + newfile + ": No such file or directory");
      }
      return true;
    } catch(Exception e){
      System.err.println(new Date() + ":" + getName() + ":" + host + ":" + uid);
      e.printStackTrace();
      return false;
    }
  }

  public String getName() {
    return "RNTO";
  }
}